
--[[

●機能概要

Lua スクリプトファイル(テキスト)をロードしてチャンクファイル(バイナリ)形式で保存する。
"infile" パラメータで指定したスクリプトファイルファイル名の最後尾に アンダースコア "_" を
付けた名前のチャンクファイル形式のスクリプトファイルが新規に作成される。
既存のファイルは上書きされる。

●リクエストパラメータ

---------------------------------------------------------------------------------
キー値			値		            									値の例
---------------------------------------------------------------------------------

infile			ロードするスクリプト名										"SAMPLE"


●リターンパラメータ

---------------------------------------------------------------------------------
キー値			値		            									値の例
---------------------------------------------------------------------------------

Stauts			処理が成功した場合には "OK" が入る
				エラーの場合にはエラーメッセージが入る
																			"OK"

●変更履歴

2020/9/12	初版作成

abs_agent copyright(c) All Blue System

]]

if not g_params["infile"] then
	script_result(g_taskid,"Status","*ERROR* infile parameter error")
	return
end

local stat,mod_stat,config = service_module_status()
local in_path = config["ScriptFolder"] .. "/" .. g_params["infile"] .. ".lua"
local out_path = config["ScriptFolder"] .. "/" .. g_params["infile"] .. "_.lua"

local chunk = loadfile(in_path)
if not chunk then 
	script_result(g_taskid,"Status","*ERROR* loadfile() error")
	return
end

local o_file = io.open(out_path,"wb")
if not o_file then 
	script_result(g_taskid,"Status","*ERROR* io.open() failed")
	return
end

o_file:write(string.dump(chunk))

o_file:close()

script_result(g_taskid,"Status","OK")
