
--[[
********************************************************************************************************************

●機能概要

グローバル共有文字列リストの全チャンネルを JSON リスト形式で取得


●リクエストパラメータ

---------------------------------------------------------------------------------
キー値			値		            									値の例
---------------------------------------------------------------------------------
csv				チャンネルリストを CSV 形式にする。
				このパラメータを省略した場合には JSON 配列形式になる	"1" 


●リターンパラメータ

---------------------------------------------------------------------------------
キー値          値                                               値の例
---------------------------------------------------------------------------------
List			グローバル共有文字列リストに登録されている全チャンネル名
				の配列
				(csv パラメータ無しの場合)						["/alarm/switch/eagle","/zb/Node1/tdcp",
																"/xbee/Device4/tdcp","/alarm/signal/eagle","abc"]

				(csv パラメータありの場合)						/alarm/switch/eagle,/zb/Node1/tdcp,/xbee/Device4/tdcp,
																/alarm/signal/eagle,abc

●備考

Web API 経由でこのスクリプトをアクセスする場合には、下記の URL にアクセスして下さい。
リクエストURL例

http://<hostname>:<port>/command/json/script?name=ETC/SHARED_STRLIST_CHANNELS&session=<session_token>&noquote=1

URL パラメータに noquote=1 を指定することで、リターンパラメータ値("List") を直接 JSON オブジェクトとして
扱うことができます。

レスポンスJSON文字列例

 {"Result":"Success","ErrorText":"","TaskID":"LUA042F2FA68B30AD","ResultParams":{"List":["/alarm/switch/eagle",
"/zb/Node1/tdcp","/xbee/Device4/tdcp","/alarm/signal/eagle","abc"]}}

●変更履歴

2016/11/26    初版作成

abs_agent  copyright(c) All Blue System

********************************************************************************************************************
]]

local stat,channels = list_shared_strlist()
if not stat then error() end
local msg = ""
if g_params["csv"] then
	for k,v in ipairs(channels) do
		if k > 1 then msg = msg .. ',' end
		msg = msg .. v
	end
else
	msg = "["
	for k,v in ipairs(channels) do
		if k > 1 then msg = msg .. ',' end
		msg = msg .. '"' .. v .. '"'
	end
	msg = msg .. "]"
end
script_result(g_taskid,"List",msg)

