
--[[

●機能概要

MGCP heatbeat イベントメッセージを MQTT ブローカー経由で送信します。

MGCP デバイスからのイベント受信をおこなっている全ての MGCP デバイスクライアント
がこのイベントデータを受信します。

●リクエストパラメータ

なし

●リターンパラメータ

---------------------------------------------------------------------------------
キー値			値		            									値の例
---------------------------------------------------------------------------------
Stauts			処理が成功した場合には "OK" が入る
																		"OK"

●備考

MQTT に登録済みで且つ、接続中のブローカーに対して MGCP heartbeat イベントメッセージを送信します。

●変更履歴

2021/1/29	送信先ブローカを全エンドポイントに変更

2021/1/2	スクリプト名変更

2018/8/5	初版作成

abs_agent copyright(c) All Blue System

]]

----------------------------------------------
-- 最新のエンドポイントリストを取得
----------------------------------------------
local enable, ready, title, id = stat_check(mqtt_all_list())
for key,val in ipairs(id) do
    ----------------------------------------------------------------------------
    -- 現在ソケット接続中でエラーが発生していないエンドポイントのみを対象にする
    ----------------------------------------------------------------------------
    if enable[key] and ready[key] then
		----------------------------------------------
		-- heartbeat イベントを送信
		----------------------------------------------
		if not mqtt_publish(id[key],"/event/_ALL_/" .. g_hostname .. "/abs_agent/heartbeat",'{}',0) then
			log_msg("*ERROR* mqtt_publish() failed. [" .. id[key] .. "]")
		end
    end
end
script_result("Status","OK")

--[[
local mgcp_endpoints = stat_check(get_shared_strlist('$MGCP_EndPointList'))
if #mgcp_endpoints > 0 then
	if not mgcp_event("_ALL_","heartbeat",'{}') then error() end
end
]]
