
file_id = "MQTT_DISCONNECT_ALL"

--[[

●機能概要

接続中の MQTT エンドポイントリストの接続を終了する。


●リクエストパラメータ
---------------------------------------------------------------------------------
キー値            値                                                        値の例
---------------------------------------------------------------------------------

●リターンパラメータ
---------------------------------------------------------------------------------
キー値            値                                                        値の例
---------------------------------------------------------------------------------

●備考

サーバー設定プログラムで登録された MQTT エンドポイントで現在 Broker に接続中のもの
に対して以下の動作を行います。

mqtt_disconnect() を使用して ブローカに切断リクエストを送信
mqtt_clse() を使用してソケット削除

●変更履歴

2016/06/01  abs_agent 用に移植

2015/05/13    初版作成 for ABS-9000 DeviceServer

]]

----------------------------------------------
-- 最新のエンドポイントリストを取得
----------------------------------------------
local stat, enable, ready, title, id, host, port, subscribe_topic_list, subscribe_qos_list,
    user, password, will_topic, will_message, will_qos, will_retain, recv_buff_size,log = mqtt_all_list()
if not stat then error() end

----------------------------------------------
-- エンドポイントに確立済みのソケット削除
----------------------------------------------
for key,val in ipairs(id) do

    ------------------------------------------------------
    -- 現在ソケット接続しているエンドポイントを対象にする
    ------------------------------------------------------
    if enable[key] then

        if ready[key] then
            -------------------------------------------------------------------------
            -- Broker への通信が正常なエンドポイントには DISCONNECT メッセージを送信
            -------------------------------------------------------------------------
            mqtt_disconnect(id[key])
        end
        --------------------------------
        -- エンドポイントのソケット削除
        --------------------------------
        mqtt_close(id[key])
    end
end

