
file_id = "SERIAL_RAW"

--[[

******************************************************************************

一つのスクリプトの実行は長くても数秒以内で必ず終了するようにしてください。
処理に時間がかかると、イベント処理の終了を待つサーバー側でタイムアウトが発生します。

また、同時実行可能なスクリプトの数に制限があるため、他のスクリプトの実行開始が
待たされる原因にもなります。

頻繁には発生しないイベントで、処理時間がかかるスクリプトを実行したい場合は
スクリプトを別に作成して、このイベントハンドラ中から script_fork_exec() を使用して
別スレッドで実行することを検討してください。

******************************************************************************


SERIAL_RAW スクリプト起動時に渡される追加パラメータ

---------------------------------------------------------------------------------
キー値          値                                                  値の例
---------------------------------------------------------------------------------
COMPort         データを送信したシリアルデバイスファイル名          "/dev/ttyUSB0"

Title           データを送信したシリアルデバイスのタイトル名        "コントローラ#1"
                タイトルが設定されていない場合にはこのパラメータは
                設定されません

RAW_DATA        シリアルデバイスから読み込んだバイナリデータ。
                (16進数、可変長)                                    "0102030A0B"

]]

-------------------------------------------------------------
-- シリアルデバイスから読み込んだバイナリデータをログに出力
-------------------------------------------------------------
local str = ""
for key,val in pairs(g_params) do
    str = str .. key .. " = " .. val .. " "
end
log_msg(str,file_id);

