
file_id = "SERIAL_STRING"

--[[

******************************************************************************

一つのスクリプトの実行は長くても数秒以内で必ず終了するようにしてください。
処理に時間がかかると、イベント処理の終了を待つサーバー側でタイムアウトが発生します。

また、同時実行可能なスクリプトの数に制限があるため、他のスクリプトの実行開始が
待たされる原因にもなります。

頻繁には発生しないイベントで、処理時間がかかるスクリプトを実行したい場合は
スクリプトを別に作成して、このイベントハンドラ中から script_fork_exec() を使用して
別スレッドで実行することを検討してください。

******************************************************************************


SERIAL_STRING スクリプト起動時に渡される追加パラメータ

---------------------------------------------------------------------------------
キー値          値                                                      値の例
---------------------------------------------------------------------------------
COMPort         イベントを送信したシリアルデバイスのデバイスファイル名  "/dev/ttyUSB0"

Title           イベントを送信したシリアルデバイスのタイトル名          "コントローラ#1"
                タイトルが設定されていない場合にはこのパラメータは
                設定されません

STRING          シリアルデバイスから入力された文字列                    "string data"

                文字列は、下記の何れかのデータで終端されたものです。
                ヌル文字(0x00),CR(0x0D),LF(0x0A),CR-LF(0x0D,0x0A)

                STRING パラメータには、終端文字を含まない文字列部分が格納されています

]]

-----------------------------------------------------
-- シリアルデバイスから読み込んだ文字列をログに出力
-----------------------------------------------------
log_msg(g_params["Title"] .. "[" .. g_params["COMPort"] .. "] " .. g_params["STRING"],file_id)



-- NMEA-0183 メッセージをグローバル共有変数に格納する。 第一カラムの NMEA センテンス名をキー名とする
--  (詳しくはユーザーマニュアルを参照してください)
--[[
if string.sub(g_params["STRING"],1,1) == '$' then
	local arr = csv_to_tbl(g_params["STRING"])
	if not set_shared_data(arr[1],g_params["STRING"]) then error() end
end
]]
