
--[[
******************************************************************************
このスクリプトは abs_agent 起動時にコールされます
このスクリプトの実行は長くても数秒以内で必ず終了するようにしてください。
******************************************************************************
]]
log_msg("start..")

---------------------------------------------------------------
-- MQTT モジュールが有効な場合に全てのエンドポイント接続の開始
---------------------------------------------------------------
local mstat,module_stat = service_module_status()
if not mstat then error() end
if module_stat["MQTT"] then 
    script_fork_exec("MQTT_CONNECT_ALL","","")
end

--[[

認証を省略してアクセスするためのセッションを作成する。
下記のコメントを削除すると、create_session() ライブラリ関数をコールするときの
第一パラメータに記述したセッショントークンが abs_agent 起動時に自動作成されます。
第二パラメータを true にして、セッションを使用しない場合でも自動削除対象とならない
ようにしています。Web API から abs_agent をアクセスするときに、ログイン認証を
省略したい場合に、ここで指定したセッショントークン文字列を "session" URLパラメータ
に指定できます。

*** 重要 ***
コメントアウトする時には、セッショントークン文字列を任意の文字列に変更してください

]]
-- if not create_session("1234",true) then error() end

-----------------------------------------------------------------
-- FASTDB の過去データ保存期間を 30日に設定する例(default 10日)
-- FASTDB_PURGE.lua スクリプト内で使用する
-----------------------------------------------------------------
-- set_shared_data("$FASTDB_PURGE_BEFORE","30")

-----------------------------------------------------------------------------
-- リモートアクセスタイムアウトのリセット時間を3分に設定する例(default 10分)
-- REMOTE_LOST_HOSTS_RESET.lua スクリプト内で使用する
-----------------------------------------------------------------------------
-- set_shared_data("$REMOTE_LOST_HOSTS_CLEAR_TIME","3")
