//
// 	abs_agent FASTDB RawDataチャート Webアプリケーション
//	
//  2018/11/05	ver1.0  abs_agent 集計アプリを元に初版作成
//
// copyright(c)  All Rights Reserved 2014-2018 All Blue System
//

// スクリプト実行結果ステータスのみをチェック
function script_exec_callback(data){
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("#login_password").val("");
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_back_dialog", { transition: "pop",role:"dialog" });
		}
	} 
}

// UI コンポーネントの xml 属性値を検索取得
function getAttrVal(node,name){
	var val = "";
	var attr =  node.attributes;
	for (var i=0; i<attr.length; i++){
		if (attr[i].nodeName == name){
			val = attr[i].nodeValue;
		}
	}
	return val;
}

// chart_disp_page /////////////////////////////////////////////////////

// Line チャート表示
function plot_chart_line(data){
	$.mobile.loading( 'hide');
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_prev_dialog", { transition: "pop",role:"dialog" });
		}
		return;
	}

	var yaxis_min = $("#yaxis_min").val();
	if (yaxis_min != ""){
		var yaxis_val = {
                rendererOptions: {
                    minorTicks: 1
                },
				label:" ", // 左マージンの為にダミーを配置
                min: parseInt(yaxis_min),
                tickOptions: {
                    formatString: "%g",
                    showMark: false,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                }
            };

	} else {
		var yaxis_val = {
                rendererOptions: {
                    minorTicks: 1
                },
				label:" ", // 左マージンの為にダミーを配置
                //min: 0,
                tickOptions: {
                    formatString: "%g",
                    showMark: false,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                }
            };
	}

	if ($("#point_label_chk").prop("checked")) {
		var series_def_val = {
			//rendererOptions: { smooth: true },
			pointLabels: { show:true},
            breakOnNull: true
        };
	} else {
		var series_def_val = {
			//rendererOptions: { smooth: true },
            breakOnNull: true
        };
	}

	// jqplot ライブラリを使用してチャート表示
	// プロットデータとラベルはスクリプトリターンパラメータから取得する
	var plot1 = $.jqplot('chartdiv',data.ResultParams.SeriesList,{
		seriesDefaults: series_def_val,
		series: data.ResultParams.LabelList,
		legend:{
			show: true
		},
		highlighter: {
			show: true,
			sizeAdjust: 7.5
      	},

		axes: {
            xaxis: {
                renderer: $.jqplot.DateAxisRenderer,
                tickOptions: {
                    formatString: "%m/%d %H:%M",
                    angle: -30,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                },
                drawMajorGridlines: true
            },
            yaxis:yaxis_val
        },
		cursor:{show: true,zoom:true}
	});
}

// abs_agent に設置した検索スクリプトを起動して、検索パラメータで指定された
// シリーズデータを取得する。スクリプト完了時のイベントハンドラでグラフを描画する
function plot_chart(){
	$('#chartdiv').empty();
	$.mobile.loading( 'show');

	// abs_agent のFASTDB 検索スクリプトを起動する
	var params = {};
	params["noquote"] = "1";	// スクリプトリターンパラメータを JSON オブジェクトとして受信する
	params["KeyList"] = selected_keys;
	params["Direction"] = $('input[name=search_method]:checked').val();
	var target_date_from = $("#target_date_from").val();
	if (target_date_from != ""){
		params["TargetDateFrom"] = target_date_from;
	}
	var target_time_from = $("#target_time_from").val();
	if (target_time_from != ""){
		params["TargetTimeFrom"] = target_time_from;
	}
	var target_date_until = $("#target_date_until").val();
	if (target_date_until != ""){
		params["TargetDateUntil"] = target_date_until;
	}
	var target_time_until = $("#target_time_until").val();
	if (target_time_until != ""){
		params["TargetTimeUntil"] = target_time_until;
	}
	var maxlist = $("#maxlist").val();
	if (maxlist != ""){
		params["MaxList"] = maxlist;
	}

	script_exec("FASTDB/SEARCH_JSON",params,"plot_chart_line");
}

// チャート画面が表示された
$(document).on("pageshow","#chart_disp_page",function(event){
	plot_chart();
});

// チャート画面の Redrawボタンが操作された
$("#chart_disp_redraw_btn").on( "click",function(event, ui){
	plot_chart();
});

// チャート画面の Prevボタンが操作された
$("#chart_disp_prev_btn").on( "click",function(event, ui){
	$("body").pagecontainer("change","#chart_params_page", { transition: "none" });
});

// 検索スクリプト実行中エラーのダイアログから復帰する場合は検索パラメータ設定画面に戻る
// グラフ画面の Prevボタンが操作された
$("#error_prev_ok_btn").on( "click",function(event, ui){
	$("body").pagecontainer("change","#chart_params_page", { transition: "none" });
});

// chart_params_page ///////////////////////////////////////////////////////

// 検索パラメータ設定画面の Nextボタンが操作された
$("#summary_params_next_btn").on( "click",function(event, ui){
	$("body").pagecontainer("change","#chart_disp_page", { transition: "none" });
});

// 検索パラメータ設定画面の Prevボタンが操作された
$("#summary_params_prev_btn").on( "click",function(event, ui){
	$("body").pagecontainer("change","#select_keys_page", { transition: "none" });
});

// 検索対象キーのテキスト入力コンポーネントの内容が変更された
$(document).on("change", "#target_keys", function () {
	selected_keys = $("#target_keys").val();
});

// 検索パラメータ設定画面が表示された
$(document).on("pageshow","#chart_params_page",function(event){
	$("#target_keys").val(selected_keys);	// 前ページで選択した全てのキーを、テキストエリアに初期値として入力
});

// select_keys_page /////////////////////////////////////////////////////////

// 検索対象の FASTDBキー名リスト(カンマ区切り)
// チェックボックスを操作すると update_selected_keys() イベントハンドラが実行されて
// 常に最新のチェック状態を反映している
var selected_keys = "";

// FASTDB データベースで使用中のキー名リストを取得する
function get_key_list(){
	var params = {};
	params["noquote"] = "1";		// スクリプトリターンパラメータを JSON オブジェクトとして受信する
	script_exec("FASTDB/KEYS_JSON",params,"get_key_list_handler");
}

// FASTDB/KEYS_JSON スクリプト実行結果のイベントハンドラ。
function get_key_list_handler(data){
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_back_dialog", { transition: "pop",role:"dialog" });
		}
		return;
	}

	// 選択済みのキーがある場合にはチェックボックスをチェック済みにする
	var selected_arr = selected_keys.split(",");

	// キー名リストからチェックボックスリストを作成する
	$('#key_list').empty();
	for(i in data.ResultParams.KeyList){
		var item =  data.ResultParams.KeyList[i].Key;
		if ($.inArray(item,selected_arr) >= 0) { // 既に選択済み?
			$('#key_list').append('<input type="checkbox" name="' + item + '" id="' + item + 
						'"checked="checked" class="key_select" /><label for="' + item + '">' + item + '</label>');
		} else {
			$('#key_list').append('<input type="checkbox" name="' + item + '" id="' + item + 
						'" class="key_select" /><label for="' + item + '">' + item + '</label>');
		}
	}
	$("#key_list").trigger('create');
}

// チェックボックスで選択されているキーのリストを selected_keys に反映させる
function update_selected_keys(){
	var first = true;
	selected_keys = ""; // キーが少なくとも１つ以上選択されているかを調べる
	$(".key_select:checked").each(function(index, checkbox){
		var key_name = checkbox.name;
		if(first) {
			first = false;
		} else {
			selected_keys = selected_keys + ",";
		}
  		selected_keys = selected_keys + key_name;
	});
};

// 検索対象キーのチェックボックスが操作された
$(document).on("change", ".key_select", function () {
	update_selected_keys();
});

// 検索対象キー選択画面が表示された
$(document).on("pageshow","#select_keys_page",function(event){
	get_key_list();
});

// 検索対象キー選択画面の Reloadボタンが操作された
$("#key_list_reload_btn").on( "click",function(event, ui){
	update_selected_keys(); // チェック済みのキーが FASTDB で削除されているかもしれないので selected_keys を作成し直す
	get_key_list();
});

// 検索対象キー選択画面の Nextボタンが操作された
$("#key_list_next_btn").on( "click",function(event, ui){
	update_selected_keys(); // チェック済みのキーが FASTDB で削除されているかもしれないので selected_keys を作成し直す
	if (selected_keys == ""){ // キーが未指定の場合にはエラー
		$("body").pagecontainer("change","#key_select_error_dialog", { transition: "pop",role:"dialog" });
		return;
	}
	$("body").pagecontainer("change","#chart_params_page", { transition: "none" });
});

// login ////////////////////////////////////////////////////////////////
 
// サーバー側でログイン操作が成功したらキー選択画面に移動する
function login_callback(data){
	if (data.Result == "Success"){
		session_token = data.SessionToken;
		$("body").pagecontainer("change","#select_keys_page", { transition: "none" });
	} else {
		$("body").pagecontainer("change","#login_error_dialog", { transition: "pop",role:"dialog" });
	} 
}

// サーバー側のログアウト処理が完了したらログイン画面に戻る
function logout_callback(data){
	session_token = "";
	$("#login_password").val("");

	$("body").pagecontainer("change","#login", { transition: "pop" });
}

// ログインボタンを押した
$( "#login_btn" ).on( "click", function(event, ui){
	var user = $("#login_name").val();
	var pass = $("#login_password").val();
	login(user,pass,"login_callback");
});

// ログアウトボタンを押した
$( "#logout_ok_btn" ).on( "click", function(event, ui){
	logout("logout_callback");
});

// サーバーエラーのダイアログから復帰する場合はログイン画面に戻る
$( "#server_error_ok_btn" ).on( "click", function(event, ui){
	session_token = "";
	$("body").pagecontainer("change","#login", { transition: "pop" });
});

// ログインページが表示された
$(document).on("pageshow","#login",function(event){
	// セッショントークンが指定されている場合にはユーザー認証を省略する
	if (session_token != ""){
		$("body").pagecontainer("change","#select_keys_page", { transition: "pop" });
	}
});

