//
// 	abs_agent FASTDB データ集計アプリケーション
//	
//  2020/9/23   ver1.20 CSV データダウンロード機能を追加
//
//  2018/5/11   ver1.11 tick ラベルの色を少し暗くした
//
//  2017/5/20	ver1.10 DeviceServer 集計アプリを元に abs_agent 用に移植
//
//  2014/8/7	ver1.00 初版作成
//
//  copyright(c)2014-2020  All Rights Reserved  All Blue System
//

// スクリプト実行結果ステータスのみをチェック
function script_exec_callback(data){
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("#login_password").val("");
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_back_dialog", { transition: "pop",role:"dialog" });
		}
	} 
}

// UI コンポーネントの xml 属性値を検索取得
function getAttrVal(node,name){
	var val = "";
	var attr =  node.attributes;
	for (var i=0; i<attr.length; i++){
		if (attr[i].nodeName == name){
			val = attr[i].nodeValue;
		}
	}
	return val;
}

// chart_disp_page /////////////////////////////////////////////////////

var csv_arr = []; // CSV データ出力用配列、チャート表示には使用しない。

// CSV出力用の配列 csv_arr[] にロード
function load_csv_array(label_arr,data_arr){
	var keys = label_arr.length;
	var rows = data_arr[0].length;
	csv_arr.length = 0;

	// タイトル(キー名)出力
	var row_data = [];
	row_data.push('"DateTime"');
	for (var i=0;i<keys;i++){
		row_data.push('"' + label_arr[i].label + '"');
	}
	csv_arr.push(row_data);

	// データ行出力
	for (var i=0;i<rows;i++){
		row_data = [];
		row_data.push(data_arr[0][i][0]);
		for (var j=0;j<keys;j++){
			row_data.push(data_arr[j][i][1]);
		}
		csv_arr.push(row_data);
	}
}

// Line チャート表示
function plot_chart_line(data){
	$.mobile.loading( 'hide');
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_prev_dialog", { transition: "pop",role:"dialog" });
		}
		return;
	}

	load_csv_array(data.ResultParams.LabelList,data.ResultParams.SeriesList);

	var yaxis_min = $("#yaxis_min").val();
	if (yaxis_min != ""){
		var yaxis_val = {
                rendererOptions: {
                    minorTicks: 1
                },
				label:" ", // 左マージンの為にダミーを配置
                min: parseInt(yaxis_min),
                tickOptions: {
                    formatString: "%g",
                    showMark: false,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                }
            };

	} else {
		var yaxis_val = {
                rendererOptions: {
                    minorTicks: 1
                },
				label:" ", // 左マージンの為にダミーを配置
                //min: 0,
                tickOptions: {
                    formatString: "%g",
                    showMark: false,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                }
            };
	}

	// jqplot ライブラリを使用してチャート表示
	// プロットデータとラベルはスクリプトリターンパラメータから取得する
	var plot1 = $.jqplot('chartdiv',data.ResultParams.SeriesList,{
		seriesDefaults: {
            breakOnNull: true
        },
		series: data.ResultParams.LabelList,
		legend:{
			show: true
		},
		highlighter: {
			show: true,
			sizeAdjust: 7.5
      	},

		axes: {
            xaxis: {
                renderer: $.jqplot.DateAxisRenderer,
                tickOptions: {
                    formatString: "%m/%d %H:%M",
                    angle: -30,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                },
                drawMajorGridlines: true
            },
            yaxis:yaxis_val
        },
		cursor:{show: true,zoom:true}
	});
}

// Bar チャート表示
function plot_chart_bar(data){
	$.mobile.loading( 'hide');
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_prev_dialog", { transition: "pop",role:"dialog" });
		}
		return;
	}

	load_csv_array(data.ResultParams.LabelList,data.ResultParams.SeriesList);

	var yaxis_min = $("#yaxis_min").val();
	if (yaxis_min != ""){
		var yaxis_val = {
                rendererOptions: {
                    minorTicks: 1
                },
				label:" ", // 左マージンの為にダミーを配置
                min: parseInt(yaxis_min),
                tickOptions: {
                    formatString: "%g",
                    showMark: false,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                }
            };

	} else {
		var yaxis_val = {
                rendererOptions: {
                    minorTicks: 1
                },
				label:" ", // 左マージンの為にダミーを配置
                //min: 0,
                tickOptions: {
                    formatString: "%g",
                    showMark: false,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                }
            };
	}

	// jqplot ライブラリを使用してチャート表示
	// プロットデータとラベルはスクリプトリターンパラメータから取得する
	var plot1 = $.jqplot('chartdiv',data.ResultParams.SeriesList,{
		seriesDefaults: {
			renderer:$.jqplot.BarRenderer,
			rendererOptions: {
				barWidth: 4
			},
			pointLabels: { show: true }
		},
		series: data.ResultParams.LabelList,
		legend:{
			show: true
		},
		highlighter: {
			show: true// ,
      	},
		axes: {
            xaxis: {
                renderer: $.jqplot.DateAxisRenderer,
                tickOptions: {
                    formatString: "%m/%d %H:%M",
                    angle: -30,
                    //textColor: '#dddddd'
                    textColor: '#a0a0a0'
                },
                drawMajorGridlines: true
            },
            yaxis:yaxis_val
        },
		cursor:{show: true,zoom:true}
	});
}

// abs_agent に設置した集計スクリプトを起動して、集計パラメータで指定された
// シリーズデータを取得する。スクリプト完了時のイベントハンドラでグラフを描画する
function plot_chart(){
	$('#chartdiv').empty();
	$.mobile.loading( 'show');

	// DeviceServer の集計スクリプトを起動する
	var params = {};
	params["noquote"] = "1";	// スクリプトリターンパラメータを JSON オブジェクトとして受信する
	params["KeyList"] = selected_keys;
	var target_date = $("#target_date").val();
	if (target_date != ""){
		params["TargetDate"] = target_date;
	}
	var target_time = $("#target_time").val();
	if (target_time != ""){
		params["TargetTime"] = target_time;
	}
	params["Range"] = $('input[name=summary_range]:checked').val();
	params["Summary"] = $('input[name=summary_method]:checked').val();
	var summary_interval = $("#summary_interval").val();
	if (summary_interval != ""){
		params["Interval"] = summary_interval;
	}

	var plot_type =  $('input[name=plot_type]:checked').val();
	switch(plot_type){
		case "bar":
					script_exec("FASTDB/SUMMARY_JSON",params,"plot_chart_bar");
					break;
		case "line":
					script_exec("FASTDB/SUMMARY_JSON",params,"plot_chart_line");
					break;
	}
}

// グラフ画面が表示された
$(document).on("pageshow","#chart_disp_page",function(event){
	plot_chart();
});

// グラフ画面の Redrawボタンが操作された
$("#chart_disp_redraw_btn").on( "click",function(event, ui){
	plot_chart();
});

// グラフ画面の Prevボタンが操作された
$("#chart_disp_prev_btn").on( "click",function(event, ui){
	$("body").pagecontainer("change","#summary_params_page", { transition: "none" });
});

// 集計スクリプト実行中エラーのダイアログから復帰する場合は集計パラメータ設定画面に戻る
// グラフ画面の Prevボタンが操作された
$("#error_prev_ok_btn").on( "click",function(event, ui){
	$("body").pagecontainer("change","#summary_params_page", { transition: "none" });
});

// グラフ画面の CSV保存ボタンが操作された
$("#download_csv_btn").on( "click",function(event, ui){
    // 文字化け対策用 UTF-8 BOM 追加
    var bom = new Uint8Array([0xEF, 0xBB, 0xBF]);

    // load_csv_array() 関数でロードされたCSV データ配列からダウンロードデータに整形
    var csv_data = csv_arr.map(function(l){return l.join(',')}).join('\r\n');
    var blob = new Blob([bom, csv_data], { type: 'text/csv' });
    var url = (window.URL || window.webkitURL).createObjectURL(blob);
    var a = document.getElementById('downloader');
    a.download = 'summary.csv';
    a.href = url;

    $('#downloader')[0].click();
});

// summary_params_page ///////////////////////////////////////////////////////

// 集計パラメータ設定画面の Nextボタンが操作された
$("#summary_params_next_btn").on( "click",function(event, ui){
	$("body").pagecontainer("change","#chart_disp_page", { transition: "none" });
});

// 集計パラメータ設定画面の Prevボタンが操作された
$("#summary_params_prev_btn").on( "click",function(event, ui){
	$("body").pagecontainer("change","#select_keys_page", { transition: "none" });
});

// 集計対象キーのテキスト入力コンポーネントの内容が変更された
$(document).on("change", "#target_keys", function () {
	selected_keys = $("#target_keys").val();
});

// 集計パラメータ設定画面が表示された
$(document).on("pageshow","#summary_params_page",function(event){
	$("#target_keys").val(selected_keys);	// 前ページで選択した全てのキーを、テキストエリアに初期値として入力
});

// select_keys_page /////////////////////////////////////////////////////////

// 集計対象の FASTDBキー名リスト(カンマ区切り)
// チェックボックスを操作すると update_selected_keys() イベントハンドラが実行されて
// 常に最新のチェック状態を反映している
var selected_keys = "";

// FASTDB データベースで使用中のキー名リストを取得する
function get_key_list(){
	var params = {};
	params["noquote"] = "1";		// スクリプトリターンパラメータを JSON オブジェクトとして受信する
	script_exec("FASTDB/KEYS_JSON",params,"get_key_list_handler");
}

// FASTDB/KEYS_JSON スクリプト実行結果のイベントハンドラ。
function get_key_list_handler(data){
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_back_dialog", { transition: "pop",role:"dialog" });
		}
		return;
	}

	// 選択済みのキーがある場合にはチェックボックスをチェック済みにする
	var selected_arr = selected_keys.split(",");

	// キー名リストからチェックボックスリストを作成する
	$('#key_list').empty();
	for(i in data.ResultParams.KeyList){
		var item =  data.ResultParams.KeyList[i].Key;
		if ($.inArray(item,selected_arr) >= 0) { // 既に選択済み?
			$('#key_list').append('<input type="checkbox" name="' + item + '" id="' + item + 
						'"checked="checked" class="key_select" /><label for="' + item + '">' + item + '</label>');
		} else {
			$('#key_list').append('<input type="checkbox" name="' + item + '" id="' + item + 
						'" class="key_select" /><label for="' + item + '">' + item + '</label>');
		}
	}
	$("#key_list").trigger('create');
}

// チェックボックスで選択されているキーのリストを selected_keys に反映させる
function update_selected_keys(){
	var first = true;
	selected_keys = ""; // キーが少なくとも１つ以上選択されているかを調べる
	$(".key_select:checked").each(function(index, checkbox){
		var key_name = checkbox.name;
		if(first) {
			first = false;
		} else {
			selected_keys = selected_keys + ",";
		}
  		selected_keys = selected_keys + key_name;
	});
};

// 集計対象キーのチェックボックスが操作された
$(document).on("change", ".key_select", function () {
	update_selected_keys();
});

// 集計対象キー選択画面が表示された
$(document).on("pageshow","#select_keys_page",function(event){
	get_key_list();
});

// 集計対象キー選択画面の Reloadボタンが操作された
$("#key_list_reload_btn").on( "click",function(event, ui){
	update_selected_keys(); // チェック済みのキーが FASTDB で削除されているかもしれないので selected_keys を作成し直す
	get_key_list();
});

// 集計対象キー選択画面の Nextボタンが操作された
$("#key_list_next_btn").on( "click",function(event, ui){
	update_selected_keys(); // チェック済みのキーが FASTDB で削除されているかもしれないので selected_keys を作成し直す
	if (selected_keys == ""){ // キーが未指定の場合にはエラー
		$("body").pagecontainer("change","#key_select_error_dialog", { transition: "pop",role:"dialog" });
		return;
	}
	$("body").pagecontainer("change","#summary_params_page", { transition: "none" });
});

// login ////////////////////////////////////////////////////////////////
 
// サーバー側でログイン操作が成功したらデバイス選択画面に移動する
function login_callback(data){
	if (data.Result == "Success"){
		session_token = data.SessionToken;
		$("body").pagecontainer("change","#select_keys_page", { transition: "none" });
	} else {
		$("body").pagecontainer("change","#login_error_dialog", { transition: "pop",role:"dialog" });
	} 
}

// サーバー側のログアウト処理が完了したらログイン画面に戻る
function logout_callback(data){
	session_token = "";
	$("#login_password").val("");

	$("body").pagecontainer("change","#login", { transition: "pop" });
}

// ログインボタンを押した
$( "#login_btn" ).on( "click", function(event, ui){
	var user = $("#login_name").val();
	var pass = $("#login_password").val();
	login(user,pass,"login_callback");
});

// ログアウトボタンを押した
$( "#logout_ok_btn" ).on( "click", function(event, ui){
	logout("logout_callback");
});

// サーバーエラーのダイアログから復帰する場合はログイン画面に戻る
$( "#server_error_ok_btn" ).on( "click", function(event, ui){
	session_token = "";
	$("body").pagecontainer("change","#login", { transition: "pop" });
});

// ログインページが表示された
$(document).on("pageshow","#login",function(event){
	// セッショントークンが指定されている場合にはユーザー認証を省略する
	if (session_token != ""){
		$("body").pagecontainer("change","#select_keys_page", { transition: "pop" });
	}
});

