
//////////////////////////////////////
// メイン画面
//////////////////////////////////////

// 現在選択されている送信対象ノード名
var taeget_node_name = "";

// abs_agent で現在把握している最新のMGCPノード一覧を取得
function get_node_list(){
	var params = {};
	params["noquote"] = "1";		// スクリプトリターンパラメータを JSON オブジェクトとして受信
	script_exec("MGCP/NODE_LIST_JSON",params,"get_node_list_handler");
}

// MGCP/NODE_LIST_JSON スクリプト実行結果のイベントハンドラ。
function get_node_list_handler(data){
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_back_dialog", { transition: "pop",role:"dialog" });
		}
		return;
	}
	// ノード名リストからリストボックスの選択項目を再構成
	$('#target_node').empty();
	$('#target_node').append('<option value="">全ノード</option>');
	for(i in data.ResultParams.NodeList){
		var item =  data.ResultParams.NodeList[i].Node;
		$('#target_node').append('<option value="' + item + '">' + item + '</option>');
	}
	$("#target_node").selectmenu("refresh");
	taeget_node_name = "";
}

// 送信先ノードを選択した
$(document).on("change", "#target_node", function () {
	taeget_node_name = $("#target_node").val();
});

// 送信先リスト更新ボタン押した
$("#node_list_reload_btn").on( "click",function(event, ui){
	get_node_list();
});

// メッセージ送信スクリプト実行時のエラーチェック
function send_msg_handler(data){
	if (data.Result != "Success"){
		if(data.ErrorText.match(/CertifyUpdateSession failed/i)) {
			$("body").pagecontainer("change","#error_quit_dialog", { transition: "pop",role:"dialog" });
		} else {
			$("body").pagecontainer("change","#error_back_dialog", { transition: "pop",role:"dialog" });
		}
		return;
	}
}

// メッセージ送信スクリプト実行
function send_msg(){
	var msg = $("#send_text").val();
	var params = {};
	params["noquote"] = "1";		// スクリプトリターンパラメータを JSON オブジェクトとして受信
	if (msg == ""){
		return;					// メッセージが空の場合は送信しない
	} else {
		params["data"] = msg;
	}
	if (taeget_node_name != ""){	// 送信先パラメータを省略すると全ノードに送信
		params["node"] = taeget_node_name;
	}
	if ($("#attn_sw").val() == "on"){
		params["attn"] = "1";
	}
	script_exec("MGCP/DEVICE/M5_LCD_MSG",params,"send_msg_handler");
}

// メッセージ送信ボタン押した
$("#send_btn").on( "click",function(event, ui){
	send_msg();
});

// メインページが表示された
$(document).on("pageshow","#main_page",function(event){
	get_node_list();
});

//////////////////////////////////////
// ログイン画面
//////////////////////////////////////
 
// サーバー側のログイン処理が成功したらメイン画面に移動
function login_callback(data){
	if (data.Result == "Success"){
		session_token = data.SessionToken;
		$("body").pagecontainer("change","#main_page", { transition: "none" });
	} else {
		$("body").pagecontainer("change","#login_error_dialog", { transition: "pop",role:"dialog" });
	} 
}

// サーバー側のログアウト処理が完了したらログイン画面に戻る
function logout_callback(data){
	session_token = "";
	$("#login_password").val("");
	$("body").pagecontainer("change","#login", { transition: "pop" });
}

// ログインボタン押した
$( "#login_btn" ).on( "click", function(event, ui){
	var user = $("#login_name").val();
	var pass = $("#login_password").val();
	login(user,pass,"login_callback");
});

// ログアウトボタン押した
$( "#logout_ok_btn" ).on( "click", function(event, ui){
	logout("logout_callback");
});

// サーバーエラーのダイアログから復帰する場合はログイン画面に戻る
$( "#server_error_ok_btn" ).on( "click", function(event, ui){
	session_token = "";
	$("body").pagecontainer("change","#login", { transition: "pop" });
});

// ログインページが表示された
$(document).on("pageshow","#login",function(event){
	// 暗黙のセッショントークンが指定されている場合にはユーザー認証を省略
	if (session_token != ""){
		$("body").pagecontainer("change","#main_page", { transition: "pop" });
	}
});
